#!/usr/bin/php
<?php

#################################################################
# This script is called by openvpn daemon whenever a client 
# connection is terminated (--client-disconnect parameter in ovpn 
# config file).   
#
# Client's ovpn_cn and real_ip are passed to this script 
# through environmental variables 'common_name' and 'trusted_ip'.

function logger($facility, $msg)
{
  openlog("CustomerServer", LOG_PID | LOG_NDELAY, LOG_LOCAL0);
  syslog($facility, $msg);  
}

$device_id      = getenv('common_name');
$bytes_received = getenv('bytes_received');
$bytes_sent     = getenv('bytes_sent');
$uptime         = time() - getenv('time_unix'); # 'time_unix' holds timestamp of the moment when the client came online.

$phpclientapi = new CSPhpClientApi();
try {
  $phpclientapi->set_router_offline($device_id);
  $phpclientapi->add_connlog_disconnect($device_id, $bytes_received, $bytes_sent, $uptime);
} catch(Exception $exception) {
  logger(LOG_ERR, $exception->getMessage());
  exit(1);
}
