import sqlite3
from os             import path
from subprocess     import check_output

g_dir_vpnportal_dst      = '/opt/vpnportal/'
g_dir_cs_dst             = g_dir_vpnportal_dst + 'customer_server/'
g_dir_cs_database_dst    = g_dir_cs_dst + 'database/'
g_file_cs_db             = g_dir_cs_database_dst + 'database.db'
g_file_cs_settings       = g_dir_cs_database_dst + 'settings.db'

####################################################################
# Class for manipulation with any database.
class Database:
  def __init__(self, db_path):
    self.db_path = db_path
    if not path.exists(db_path):
      raise RuntimeError("Database file '" + db_path + "' does not exist.")
  
  def run(self, cmd):
    conn = sqlite3.connect(self.db_path)
    cursor = conn.cursor()
    with conn:
      if cmd.count(';') <= 1:
        cursor.execute(cmd)
      else:
        cursor.executescript(cmd)
      conn.commit()
      rows = cursor.fetchall()
    return rows 
 
  def sqlite_dump(self):
    return str(check_output(["sqlite3", self.db_path, ".dump"]))
         
####################################################################
# Class for accessing / modifying settings database.
class SettingsDB(Database):
  def __init__(self, db_path):
    super().__init__(db_path)

  def set_section(self, name, section_id):
    sql_cmd = 'UPDATE settings_table SET section_id = "' + section_id + '" WHERE name = "' + name + '"'
    self.run(sql_cmd)   
           
  def set_value(self, name, value):
    sql_cmd = 'UPDATE settings_table SET value = "' + value + '" WHERE name = "' + name + '"'
    self.run(sql_cmd)

  def get_value(self, name):
    sql_cmd = 'SELECT value from settings_table WHERE name = "' + name + '"'
    return self.run(sql_cmd)[0][0]
               
  def add_setting(self, section_id, name, label, value, tip_text, value_type, flags):
    sql_cmd = 'INSERT INTO settings_table VALUES ("'  + section_id  + '",' +\
                                                  '"' + name        + '",' +\
                                                  '"' + label       + '",' +\
                                                  '"' + value       + '",' +\
                                                  '"' + tip_text    + '",' +\
                                                        str(value_type)  + ','  +\
                                                        str(flags) + ')'
    self.run(sql_cmd)  
  
  def del_setting(self, name):
    sql_cmd = 'DELETE from settings_table WHERE name = "' + name + '"'
    self.run(sql_cmd)  

  def add_section(self, section_id, section_name):
    sql_cmd = 'INSERT INTO section_table VALUES ("'  + section_id  + '","' + section_name + '")'
    self.run(sql_cmd)
    
  def del_section(self, section_id):
    sql_cmd = 'DELETE from section_table WHERE section_id = "' + section_id + '"'
    self.run(sql_cmd)  
      
  
  
  
