<?php

namespace AppBundle\Controller\Ajax;

use AppBundle\Api\CsServerSettings;
use AppBundle\Api\Device;
use AppBundle\Api\FwRules;
use AppBundle\Api\StandaloneVpnClient;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class AjaxUserController
 * @package AppBundle\Controller\Ajax
 */
class AjaxBaseController extends Controller
{

    /**
     * @var Device
     */
    protected $apiDevice;

    /**
     * @var FwRules
     */
    protected $apiFwRules;

    /**
     * @var StandaloneVpnClient
     */
    protected $apiStandaloneVpnClients;

    /**
     * @var CsServerSettings
     */
    protected $apiServerSettings;

    /**
     * @param ContainerInterface|null $container
     */
    public function setContainer(ContainerInterface $container = null){

        parent::setContainer($container);

        $this->apiDevice = $this->container->get('cs_api_device');
        $this->apiFwRules = $this->container->get('cs_api_fw_rules');
        $this->apiStandaloneVpnClients = $this->container->get('cs_api_standalone_vpn_client');
        $this->apiServerSettings = $this->container->get('cs_api_server_settings');

    }

}