<?php

namespace AppBundle\Controller;

use AppBundle\Entity\User;
use AppBundle\Form\VpnClient as VpnClientForm;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class StandaloneVpnClientsController
 * @package AppBundle\Controller
 */
class StandaloneVpnClientsController extends BaseController
{

    /**
     * @Route("/standalone-vpn-clients", options = { "expose" = true }, name="app_standalone_vpn_clients")
     *
     * @param Request $request Request
     *
     * @return Response
     */
    public function standaloneVpnClientsAction(Request $request){

        return $this->render('app/pages/standaloneVpnClient/standaloneVpnClients.html.twig');

    }

    /**
     * @Route("/standalone-vpn-clients/add", options={"expose"=true}, name="app_add_standalone_vpn_client")
     *
     * @param Request $request Request
     *
     * @return Response
     */
    public function addStandaloneVpnClientAction(Request $request){

        $this->denyAccessUnlessGranted(User::ROLE_NET_ADMIN);

        $vpnClient = $this->container->get('vpn_client');

        $form = $this->createForm(VpnClientForm::class, $vpnClient);

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            /** @var \AppBundle\Api\StandaloneVpnClient $apiRoadWarrior */
            $apiStandaloneVpnClient = $this->container->get('cs_api_standalone_vpn_client');

            $result = $apiStandaloneVpnClient->addStandaloneVpnClient($vpnClient->getData());

            if($result === true){

                $this->addFlash(
                    'notice',
                    'Standalone VPN Client was successfully created.'
                );

            }else{

                $this->addFlash(
                    'error',
                    $result
                );

            }

            return $this->redirectToRoute('app_standalone_vpn_clients');

        }

        return $this->render('app/pages/standaloneVpnClient/standaloneVpnClientEdit.html.twig',
            ['title' => 'Add Standalone VPN Client', 'form' => $form->createView()]);

    }

}
