<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;

class Device extends AbstractType
{

    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options){

        /** @var \AppBundle\Api\Device $apiDevice */
        $apiDevice = $options['apiDevice'];
        $deviceId = $options['deviceId'];
        $virtualIpBase = $options['virtualIpBase'];
        $virtualMaskBase = $options['virtualMaskBase'];
        //$authorizationChecker = $options['authorizationChecker'];

        /*
        $networks = $apiDevice->getAllNetworks();
        $aNetworks = array();

        if($networks){

            foreach ($networks as $network){

                $aNetworks[$network['name']] = $network['network_id'];

            }

        }
        */

        $builder->add('lans', CollectionType::class, array(
            'entry_type' => DeviceLans::class,
            'entry_options' => [
                'label' => false,
                'apiDevice' => $apiDevice,
                'deviceId' => $deviceId,
                'virtualIpBase' => $virtualIpBase,
                'virtualMaskBase' => $virtualMaskBase,
            ],
            'error_bubbling' => false,
            'compound' => true,
        ));

        /*
        if($authorizationChecker->isGranted('ROLE_NET_MANAGER')){

            $builder->add('networks', ChoiceType::class, array(
                'label' => 'Networks',
                'choices'   => $aNetworks,
                //'expanded' => true,
                'required' => false,
                'multiple'  => true,
            ));

        }
        */

        $builder->add('save', SubmitType::class, ['label' => 'Save', 'attr' => array('class' => 'btn btn-success')])
                ->add('apply', SubmitType::class, ['label' => 'Apply', 'attr' => array('class' => 'btn btn-primary')]);

    }

    /**
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver){

        $resolver->setRequired('apiDevice');
        $resolver->setRequired('validated_disabled');
        $resolver->setRequired('deviceId');
        $resolver->setRequired('virtualIpBase');
        $resolver->setRequired('virtualMaskBase');
        //$resolver->setRequired('authorizationChecker');

    }

}