<?php

namespace AppBundle\Service;

use AppBundle\Api\CsServerSettings;
use AppBundle\Api\Device;

/**
 * Class MenuService
 * @package AppBundle\Service
 */
class MenuService{

    /**
     * @var Device
     */
    private $apiDevice;

    /**
     * @var CsServerSettings
     */
    private $apiCsServerSettings;

    /**
     * MenuService constructor.
     * @param Device $apiDevice
     * @param CsServerSettings $apiCsServerSettings
     */
    public function __construct(Device $apiDevice, CsServerSettings $apiCsServerSettings){

        $this->apiDevice = $apiDevice;
        $this->apiCsServerSettings = $apiCsServerSettings;

    }

    /**
     * @return mixed
     */
    public function getNetworks(){

        return $this->apiDevice->getAllNetworks();

    }

    /**
     * @return bool
     */
    public function getAppVersion(){

        return $this->apiCsServerSettings->getCsVersionString();

    }

}